
/*------------------------------------------------------------------------------------------

    This file is part of     FPlib V 0.3.0       Floating point library for Atmel AVR uC

    Copyright (c) Michael Stumpf   <Michael.Stumpf@t-online.de>
    ported to avr-as by Michael Rickmann      <mrickma@gwdg.de>

    for details see readme.fplib

    THE AVA COMPATIBILITY OF THIS FILE HAS NOT BEEN TESTED

 *------------------------------------------------------------------------------------------
 */

#ifndef __FPLIB_INC
#define __FPLIB_INC

;--------------------------------------------------------------------
; fp lib register nicknames

#define rA3      rP0
#define rA2      rP1
#define rA1      rP2
#define rA0      rP3
#define rAE      rTI2

#define rB3      rP4
#define rB2      rP5
#define rB1      rP6
#define rB0      rP7
#define rBE      rTI3

#define rPH      rP4            /* pointer argument */
#define rPL      rP5

#define rT0      __tmp_reg__    /* first temporary */
#define rT1c     __zero_reg__   /* 2nd temporary, clear after use */

/*---------------------------------------------------------------------
 * fp lib function declaration for ava only
 * gas treats undefined symbols as externs.
 */
#ifdef ASSEMBLER_AVA

extern ___subsf3
extern ___addsf3
extern _square
extern ___mulsf3
extern _inverse
extern ___divsf3

extern ___fp_zero
extern ___fp_nan

extern ___negsf2

extern fp_cmp
extern ___cmpsf2
extern ___eqsf2
extern ___nesf2
extern ___gtsf2
extern ___gesf2
extern ___ltsf2
extern ___lesf2

extern _sqrt
extern _ceil
extern _floor
extern _fabs
extern _fmod
extern _frexp
extern _ldexp
extern _modf

extern _cos
extern _sin
extern _tan

extern _asin
extern _acos
extern _atan

extern _exp
extern _log
extern _log10
extern _pow

extern _sinh
extern _cosh
extern _tanh

extern _fp_powerseries
extern _fp_flashconst

extern ___fixunssfsi
extern ___fixsfsi
extern ___floatunssisf
extern ___floatsisf

#endif
/*--------------------------------------------------------------------------
 * Library shapening :
 */

#define __OPTIMIZE__
/* #define __SIMPLE__NaNs simple NaNs implemented now */
/* #define __COMPLEX__NaNs */ /* not yet tested (and discarded anyway) */
/* #define __ERRNO__ */ /* not yet fully implemented */

#define EDOM   33
#define ERANGE 34

/*--------------------------------------------------------------------------
 * math function macro
 */

#ifdef ASSEMBLER_AVA
 #define LPMRdZpp(Rd) \
         LPM          \
         MOV  Rd,R0   \
         ADIW ZL,1
#else
 #define LPMRdZpp(Rd) \
	 LPM          _L \
	 MOV  Rd,R0   _L \
	 ADIW ZL,1
#endif

/*--------------------------------------------------------------------------
 * avr-as specific definitions for segments, functions and labels.
 */

#ifdef ASSEMBLER_AVA
  #define LOW(x)	low(x)
  #define HIGH(x)	high(x)
  #define DCB		dc.b
#else
  #define LOW(x)	lo8(x)
  #define HIGH(x)	hi8(x)
  #define DCB		.byte
#endif

#define ACCURACY	7	/* decimal digits */
#define retByte	rByte		/* FIXME: why has this been renamed ?  */
#ifdef ADC
# undef ADC			/* FIXME: ADC is a special register in atmega103  */
#endif				/* Why don't we use lowercase opcode mnemonics ?  */
#define ADC		adc

#endif

